"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.none = Symbol();
var MEMBER_TYPE = Symbol();
function makeTaggedUnion(defObj) {
    var MemberObject = /** @class */ (function () {
        function MemberObject(variant, data) {
            this.variant = variant;
            this.data = data;
        }
        MemberObject.prototype.match = function (casesObj) {
            var data = this.data;
            var matchingHandler = casesObj[this.variant];
            if (matchingHandler) {
                return matchingHandler(data);
            }
            else if (casesObj._) {
                return casesObj._(data);
            }
            else {
                throw new Error("Match did not handle variant: '" + this.variant + "'");
            }
        };
        return MemberObject;
    }());
    // @ts-ignore
    var matchObj = {};
    Object.keys(defObj).forEach(function (matchType) {
        var value = defObj[matchType];
        if (typeof value === "function") {
            // @ts-ignore
            matchObj[matchType] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var data = value.apply(void 0, args);
                // @ts-ignore
                return new MemberObject(matchType, data);
            };
        }
        else {
            // @ts-ignore
            matchObj[matchType] = new MemberObject(matchType);
        }
    });
    return matchObj;
}
exports.makeTaggedUnion = makeTaggedUnion;
